//-*-c++-*-
//-*-HiggsExample.cpp-*-
//-*-Example ExHuME main program to generate Higgs-*-
//   Intended as an example script of what you can do.....
//   Written by James Monk and Andrew Pilkington
/////////////////////////////////////////////////////////////////////////////
#include <cmath>

#include "Higgs.h"
#include "GG.h"
#include "QQ.h"
#include "DiPhoton.h"
#include "Event.h"

int main(int argc,char** argv){

  //Exhume::Higgs higgs (argc, argv);
  //higgs.SetHiggsDecay(5); //5 is the PDG code for b quarks
  
  Exhume::QQ higgs (argc, argv);
 
  
  Exhume::Event HiggsEvent (higgs, 1111);
  
  HiggsEvent.SetMassRange(110.0, 130.0);
  HiggsEvent.SetParameterSpace();

  double x1;
  std::vector<Exhume::Particle> HiggsInfo;
  
  for(unsigned int i=0; i!= 10; i++){
    if(fmod(i,1000)==0) std::cout<<"Processing Event "<<i<<std::endl;
    HiggsEvent.Generate();
    x1 = higgs.Getx1();
    HiggsInfo = higgs.GetPartons();
    higgs.Hadronise();
   
  }
 
  
  std::cout<<" Cross section = " 
	   <<HiggsEvent.CrossSectionCalculation()<<" fb"<<std::endl;
  std::cout<<" Efficiency of event generation = "
	   <<HiggsEvent.GetEfficiency()<<" % "<<std::endl;


  return(0);
}
/////////////////////////////////////////////////////////////////////////////
